diff -crBPN --exclude=wordpress.sql --exclude=wp-config.php --exclude=.htaccess-dist --exclude=advanced-cache.php --exclude=wp-cache-config.php --exclude=wordpress.sql --exclude=wp-config.php --exclude=.htaccess-dist --exclude=wp-cache-config.php --exclude=editor_plugin.js --exclude=jetpack --exclude=.files.list --exclude=wordpress-3.5.pl /home/packages/code/qi/SOURCES/wordpress-3.4.2/wp-includes/link-template.php /home/packages/code/qi/SOURCES/wordpress-3.5/wp-includes/link-template.php
*** /home/packages/code/qi/SOURCES/wordpress-3.4.2/wp-includes/link-template.php	2012-10-29 12:35:29.000000000 -0500
--- /home/packages/code/qi/SOURCES/wordpress-3.5/wp-includes/link-template.php	2012-12-17 16:18:39.000000000 -0600
***************
*** 54,64 ****
   *
   * @param string $mode Permalink mode can be either 'title', 'id', or default, which is 'id'.
   */
! function permalink_anchor($mode = 'id') {
! 	global $post;
! 	switch ( strtolower($mode) ) {
  		case 'title':
! 			$title = sanitize_title($post->post_title) . '-' . $post->ID;
  			echo '<a id="'.$title.'"></a>';
  			break;
  		case 'id':
--- 54,64 ----
   *
   * @param string $mode Permalink mode can be either 'title', 'id', or default, which is 'id'.
   */
! function permalink_anchor( $mode = 'id' ) {
! 	$post = get_post();
! 	switch ( strtolower( $mode ) ) {
  		case 'title':
! 			$title = sanitize_title( $post->post_title ) . '-' . $post->ID;
  			echo '<a id="'.$title.'"></a>';
  			break;
  		case 'id':
***************
*** 77,83 ****
   * @param bool $leavename Optional, defaults to false. Whether to keep post name or page name.
   * @return string
   */
! function get_permalink($id = 0, $leavename = false) {
  	$rewritecode = array(
  		'%year%',
  		'%monthnum%',
--- 77,83 ----
   * @param bool $leavename Optional, defaults to false. Whether to keep post name or page name.
   * @return string
   */
! function get_permalink( $id = 0, $leavename = false ) {
  	$rewritecode = array(
  		'%year%',
  		'%monthnum%',
***************
*** 96,102 ****
  		$post = $id;
  		$sample = true;
  	} else {
! 		$post = &get_post($id);
  		$sample = false;
  	}
  
--- 96,102 ----
  		$post = $id;
  		$sample = true;
  	} else {
! 		$post = get_post($id);
  		$sample = false;
  	}
  
***************
*** 106,112 ****
  	if ( $post->post_type == 'page' )
  		return get_page_link($post->ID, $leavename, $sample);
  	elseif ( $post->post_type == 'attachment' )
! 		return get_attachment_link($post->ID);
  	elseif ( in_array($post->post_type, get_post_types( array('_builtin' => false) ) ) )
  		return get_post_permalink($post->ID, $leavename, $sample);
  
--- 106,112 ----
  	if ( $post->post_type == 'page' )
  		return get_page_link($post->ID, $leavename, $sample);
  	elseif ( $post->post_type == 'attachment' )
! 		return get_attachment_link( $post->ID, $leavename );
  	elseif ( in_array($post->post_type, get_post_types( array('_builtin' => false) ) ) )
  		return get_post_permalink($post->ID, $leavename, $sample);
  
***************
*** 122,129 ****
  			$cats = get_the_category($post->ID);
  			if ( $cats ) {
  				usort($cats, '_usort_terms_by_ID'); // order by ID
! 				$category = $cats[0]->slug;
! 				if ( $parent = $cats[0]->parent )
  					$category = get_category_parents($parent, false, '/', true) . $category;
  			}
  			// show default category in permalinks, without
--- 122,131 ----
  			$cats = get_the_category($post->ID);
  			if ( $cats ) {
  				usort($cats, '_usort_terms_by_ID'); // order by ID
! 				$category_object = apply_filters( 'post_link_category', $cats[0], $cats, $post );
! 				$category_object = get_term( $category_object, 'category' );
! 				$category = $category_object->slug;
! 				if ( $parent = $category_object->parent )
  					$category = get_category_parents($parent, false, '/', true) . $category;
  			}
  			// show default category in permalinks, without
***************
*** 176,182 ****
  function get_post_permalink( $id = 0, $leavename = false, $sample = false ) {
  	global $wp_rewrite;
  
! 	$post = &get_post($id);
  
  	if ( is_wp_error( $post ) )
  		return $post;
--- 178,184 ----
  function get_post_permalink( $id = 0, $leavename = false, $sample = false ) {
  	global $wp_rewrite;
  
! 	$post = get_post($id);
  
  	if ( is_wp_error( $post ) )
  		return $post;
***************
*** 230,253 ****
   *
   * @since 1.5.0
   *
!  * @param int $id Optional. Post ID.
   * @param bool $leavename Optional, defaults to false. Whether to keep page name.
   * @param bool $sample Optional, defaults to false. Is it a sample permalink.
   * @return string
   */
! function get_page_link( $id = false, $leavename = false, $sample = false ) {
! 	global $post;
! 
! 	$id = (int) $id;
! 	if ( !$id )
! 		$id = (int) $post->ID;
  
! 	if ( 'page' == get_option('show_on_front') && $id == get_option('page_on_front') )
  		$link = home_url('/');
  	else
! 		$link = _get_page_link( $id , $leavename, $sample );
  
! 	return apply_filters('page_link', $link, $id, $sample);
  }
  
  /**
--- 232,251 ----
   *
   * @since 1.5.0
   *
!  * @param mixed $post Optional. Post ID or object.
   * @param bool $leavename Optional, defaults to false. Whether to keep page name.
   * @param bool $sample Optional, defaults to false. Is it a sample permalink.
   * @return string
   */
! function get_page_link( $post = false, $leavename = false, $sample = false ) {
! 	$post = get_post( $post );
  
! 	if ( 'page' == get_option( 'show_on_front' ) && $post->ID == get_option( 'page_on_front' ) )
  		$link = home_url('/');
  	else
! 		$link = _get_page_link( $post, $leavename, $sample );
  
! 	return apply_filters( 'page_link', $link, $post->ID, $sample );
  }
  
  /**
***************
*** 258,275 ****
   * @since 2.1.0
   * @access private
   *
!  * @param int $id Optional. Post ID.
   * @param bool $leavename Optional. Leave name.
   * @param bool $sample Optional. Sample permalink.
   * @return string
   */
! function _get_page_link( $id = false, $leavename = false, $sample = false ) {
! 	global $post, $wp_rewrite;
  
! 	if ( !$id )
! 		$id = (int) $post->ID;
! 	else
! 		$post = &get_post($id);
  
  	$draft_or_pending = in_array( $post->post_status, array( 'draft', 'pending', 'auto-draft' ) );
  
--- 256,270 ----
   * @since 2.1.0
   * @access private
   *
!  * @param mixed $post Optional. Post ID or object.
   * @param bool $leavename Optional. Leave name.
   * @param bool $sample Optional. Sample permalink.
   * @return string
   */
! function _get_page_link( $post = false, $leavename = false, $sample = false ) {
! 	global $wp_rewrite;
  
! 	$post = get_post( $post );
  
  	$draft_or_pending = in_array( $post->post_status, array( 'draft', 'pending', 'auto-draft' ) );
  
***************
*** 277,292 ****
  
  	if ( !empty($link) && ( ( isset($post->post_status) && !$draft_or_pending ) || $sample ) ) {
  		if ( ! $leavename ) {
! 			$link = str_replace('%pagename%', get_page_uri($id), $link);
  		}
  
  		$link = home_url($link);
  		$link = user_trailingslashit($link, 'page');
  	} else {
! 		$link = home_url("?page_id=$id");
  	}
  
! 	return apply_filters( '_get_page_link', $link, $id );
  }
  
  /**
--- 272,287 ----
  
  	if ( !empty($link) && ( ( isset($post->post_status) && !$draft_or_pending ) || $sample ) ) {
  		if ( ! $leavename ) {
! 			$link = str_replace('%pagename%', get_page_uri( $post ), $link);
  		}
  
  		$link = home_url($link);
  		$link = user_trailingslashit($link, 'page');
  	} else {
! 		$link = home_url( '?page_id=' . $post->ID );
  	}
  
! 	return apply_filters( '_get_page_link', $link, $post->ID );
  }
  
  /**
***************
*** 296,333 ****
   *
   * @since 2.0.0
   *
!  * @param int $id Optional. Post ID.
   * @return string
   */
! function get_attachment_link($id = false) {
! 	global $post, $wp_rewrite;
  
  	$link = false;
  
! 	if ( ! $id)
! 		$id = (int) $post->ID;
  
! 	$object = get_post($id);
! 	if ( $wp_rewrite->using_permalinks() && ($object->post_parent > 0) && ($object->post_parent != $id) ) {
! 		$parent = get_post($object->post_parent);
  		if ( 'page' == $parent->post_type )
! 			$parentlink = _get_page_link( $object->post_parent ); // Ignores page_on_front
  		else
! 			$parentlink = get_permalink( $object->post_parent );
  
! 		if ( is_numeric($object->post_name) || false !== strpos(get_option('permalink_structure'), '%category%') )
! 			$name = 'attachment/' . $object->post_name; // <permalink>/<int>/ is paged so we use the explicit attachment marker
  		else
! 			$name = $object->post_name;
  
  		if ( strpos($parentlink, '?') === false )
! 			$link = user_trailingslashit( trailingslashit($parentlink) . $name );
  	}
  
  	if ( ! $link )
! 		$link = home_url( "/?attachment_id=$id" );
  
! 	return apply_filters('attachment_link', $link, $id);
  }
  
  /**
--- 291,330 ----
   *
   * @since 2.0.0
   *
!  * @param mixed $post Optional. Post ID or object.
!  * @param bool $leavename Optional. Leave name.
   * @return string
   */
! function get_attachment_link( $post = null, $leavename = false ) {
! 	global $wp_rewrite;
  
  	$link = false;
  
! 	$post = get_post( $post );
  
! 	if ( $wp_rewrite->using_permalinks() && ( $post->post_parent > 0 ) && ( $post->post_parent != $post->ID ) ) {
! 		$parent = get_post($post->post_parent);
  		if ( 'page' == $parent->post_type )
! 			$parentlink = _get_page_link( $post->post_parent ); // Ignores page_on_front
  		else
! 			$parentlink = get_permalink( $post->post_parent );
  
! 		if ( is_numeric($post->post_name) || false !== strpos(get_option('permalink_structure'), '%category%') )
! 			$name = 'attachment/' . $post->post_name; // <permalink>/<int>/ is paged so we use the explicit attachment marker
  		else
! 			$name = $post->post_name;
  
  		if ( strpos($parentlink, '?') === false )
! 			$link = user_trailingslashit( trailingslashit($parentlink) . '%postname%' );
! 
! 		if ( ! $leavename )
! 			$link = str_replace( '%postname%', $name, $link );
  	}
  
  	if ( ! $link )
! 		$link = home_url( '/?attachment_id=' . $post->ID );
  
! 	return apply_filters( 'attachment_link', $link, $post->ID );
  }
  
  /**
***************
*** 487,495 ****
  	} else {
  		$type = get_post_field('post_type', $post_id);
  		if ( 'page' == $type )
! 			$url = home_url("?feed=$feed&amp;page_id=$post_id");
  		else
! 			$url = home_url("?feed=$feed&amp;p=$post_id");
  	}
  
  	return apply_filters('post_comments_feed_link', $url);
--- 484,492 ----
  	} else {
  		$type = get_post_field('post_type', $post_id);
  		if ( 'page' == $type )
! 			$url = add_query_arg( array( 'feed' => $feed, 'page_id' => $post_id ), home_url( '/' ) );
  		else
! 			$url = add_query_arg( array( 'feed' => $feed, 'p' => $post_id ), home_url( '/' ) );
  	}
  
  	return apply_filters('post_comments_feed_link', $url);
***************
*** 512,518 ****
   * @return string Link to the comment feed for the current post.
  */
  function post_comments_feed_link( $link_text = '', $post_id = '', $feed = '' ) {
! 	$url = get_post_comments_feed_link($post_id, $feed);
  	if ( empty($link_text) )
  		$link_text = __('Comments Feed');
  
--- 509,515 ----
   * @return string Link to the comment feed for the current post.
  */
  function post_comments_feed_link( $link_text = '', $post_id = '', $feed = '' ) {
! 	$url = esc_url( get_post_comments_feed_link( $post_id, $feed ) );
  	if ( empty($link_text) )
  		$link_text = __('Comments Feed');
  
***************
*** 624,630 ****
  	if ( 'category' == $taxonomy )
  		$link = apply_filters( 'category_feed_link', $link, $feed );
  	elseif ( 'post_tag' == $taxonomy )
! 		$link = apply_filters( 'category_feed_link', $link, $feed );
  	else
  		$link = apply_filters( 'taxonomy_feed_link', $link, $feed, $taxonomy );
  
--- 621,627 ----
  	if ( 'category' == $taxonomy )
  		$link = apply_filters( 'category_feed_link', $link, $feed );
  	elseif ( 'post_tag' == $taxonomy )
! 		$link = apply_filters( 'tag_feed_link', $link, $feed );
  	else
  		$link = apply_filters( 'taxonomy_feed_link', $link, $feed, $taxonomy );
  
***************
*** 896,902 ****
   * @return string
   */
  function get_edit_post_link( $id = 0, $context = 'display' ) {
! 	if ( !$post = &get_post( $id ) )
  		return;
  
  	if ( 'display' == $context )
--- 893,899 ----
   * @return string
   */
  function get_edit_post_link( $id = 0, $context = 'display' ) {
! 	if ( ! $post = get_post( $id ) )
  		return;
  
  	if ( 'display' == $context )
***************
*** 925,931 ****
   * @param int $id Optional. Post ID.
   */
  function edit_post_link( $link = null, $before = '', $after = '', $id = 0 ) {
! 	if ( !$post = &get_post( $id ) )
  		return;
  
  	if ( !$url = get_edit_post_link( $post->ID ) )
--- 922,928 ----
   * @param int $id Optional. Post ID.
   */
  function edit_post_link( $link = null, $before = '', $after = '', $id = 0 ) {
! 	if ( !$post = get_post( $id ) )
  		return;
  
  	if ( !$url = get_edit_post_link( $post->ID ) )
***************
*** 955,961 ****
  	if ( ! empty( $deprecated ) )
  		_deprecated_argument( __FUNCTION__, '3.0' );
  
! 	if ( !$post = &get_post( $id ) )
  		return;
  
  	$post_type_object = get_post_type_object( $post->post_type );
--- 952,958 ----
  	if ( ! empty( $deprecated ) )
  		_deprecated_argument( __FUNCTION__, '3.0' );
  
! 	if ( !$post = get_post( $id ) )
  		return;
  
  	$post_type_object = get_post_type_object( $post->post_type );
***************
*** 969,975 ****
  
  	$delete_link = add_query_arg( 'action', $action, admin_url( sprintf( $post_type_object->_edit_link, $post->ID ) ) );
  
! 	return apply_filters( 'get_delete_post_link', wp_nonce_url( $delete_link, "$action-{$post->post_type}_{$post->ID}" ), $post->ID, $force_delete );
  }
  
  /**
--- 966,972 ----
  
  	$delete_link = add_query_arg( 'action', $action, admin_url( sprintf( $post_type_object->_edit_link, $post->ID ) ) );
  
! 	return apply_filters( 'get_delete_post_link', wp_nonce_url( $delete_link, "$action-post_{$post->ID}" ), $post->ID, $force_delete );
  }
  
  /**
***************
*** 981,987 ****
   * @return string
   */
  function get_edit_comment_link( $comment_id = 0 ) {
! 	$comment = &get_comment( $comment_id );
  
  	if ( !current_user_can( 'edit_comment', $comment->comment_ID ) )
  		return;
--- 978,984 ----
   * @return string
   */
  function get_edit_comment_link( $comment_id = 0 ) {
! 	$comment = get_comment( $comment_id );
  
  	if ( !current_user_can( 'edit_comment', $comment->comment_ID ) )
  		return;
***************
*** 1054,1059 ****
--- 1051,1084 ----
  	echo $before . apply_filters( 'edit_bookmark_link', $link, $bookmark->link_id ) . $after;
  }
  
+ /**
+  * Retrieve edit user link
+  *
+  * @since 3.5.0
+  *
+  * @param int $user_id Optional. User ID. Defaults to the current user.
+  * @return string URL to edit user page or empty string.
+  */
+ function get_edit_user_link( $user_id = null ) {
+ 	if ( ! $user_id )
+ 		$user_id = get_current_user_id();
+ 
+ 	if ( empty( $user_id ) || ! current_user_can( 'edit_user', $user_id ) )
+ 		return '';
+ 
+ 	$user = get_userdata( $user_id );
+ 
+ 	if ( ! $user )
+ 		return '';
+ 
+ 	if ( get_current_user_id() == $user->ID )
+ 		$link = get_edit_profile_url( $user->ID );
+ 	else
+ 		$link = add_query_arg( 'user_id', $user->ID, self_admin_url( 'user-edit.php' ) );
+ 
+ 	return apply_filters( 'get_edit_user_link', $link, $user->ID );
+ }
+ 
  // Navigation links
  
  /**
***************
*** 1095,1103 ****
   * @return mixed Post object if successful. Null if global $post is not set. Empty string if no corresponding post exists.
   */
  function get_adjacent_post( $in_same_cat = false, $excluded_categories = '', $previous = true ) {
! 	global $post, $wpdb;
  
! 	if ( empty( $post ) )
  		return null;
  
  	$current_post_date = $post->post_date;
--- 1120,1128 ----
   * @return mixed Post object if successful. Null if global $post is not set. Empty string if no corresponding post exists.
   */
  function get_adjacent_post( $in_same_cat = false, $excluded_categories = '', $previous = true ) {
! 	global $wpdb;
  
! 	if ( ! $post = get_post() )
  		return null;
  
  	$current_post_date = $post->post_date;
***************
*** 1108,1114 ****
--- 1133,1143 ----
  		$join = " INNER JOIN $wpdb->term_relationships AS tr ON p.ID = tr.object_id INNER JOIN $wpdb->term_taxonomy tt ON tr.term_taxonomy_id = tt.term_taxonomy_id";
  
  		if ( $in_same_cat ) {
+ 			if ( ! is_object_in_taxonomy( $post->post_type, 'category' ) )
+ 				return '';
  			$cat_array = wp_get_object_terms($post->ID, 'category', array('fields' => 'ids'));
+ 			if ( ! $cat_array || is_wp_error( $cat_array ) )
+ 				return '';
  			$join .= " AND tt.taxonomy = 'category' AND tt.term_id IN (" . implode(',', $cat_array) . ")";
  		}
  
***************
*** 1145,1161 ****
  	$where = apply_filters( "get_{$adjacent}_post_where", $wpdb->prepare("WHERE p.post_date $op %s AND p.post_type = %s AND p.post_status = 'publish' $posts_in_ex_cats_sql", $current_post_date, $post->post_type), $in_same_cat, $excluded_categories );
  	$sort  = apply_filters( "get_{$adjacent}_post_sort", "ORDER BY p.post_date $order LIMIT 1" );
  
! 	$query = "SELECT p.* FROM $wpdb->posts AS p $join $where $sort";
  	$query_key = 'adjacent_post_' . md5($query);
  	$result = wp_cache_get($query_key, 'counts');
! 	if ( false !== $result )
  		return $result;
  
! 	$result = $wpdb->get_row("SELECT p.* FROM $wpdb->posts AS p $join $where $sort");
  	if ( null === $result )
  		$result = '';
  
  	wp_cache_set($query_key, $result, 'counts');
  	return $result;
  }
  
--- 1174,1197 ----
  	$where = apply_filters( "get_{$adjacent}_post_where", $wpdb->prepare("WHERE p.post_date $op %s AND p.post_type = %s AND p.post_status = 'publish' $posts_in_ex_cats_sql", $current_post_date, $post->post_type), $in_same_cat, $excluded_categories );
  	$sort  = apply_filters( "get_{$adjacent}_post_sort", "ORDER BY p.post_date $order LIMIT 1" );
  
! 	$query = "SELECT p.id FROM $wpdb->posts AS p $join $where $sort";
  	$query_key = 'adjacent_post_' . md5($query);
  	$result = wp_cache_get($query_key, 'counts');
! 	if ( false !== $result ) {
! 		if ( $result )
! 			$result = get_post( $result );
  		return $result;
+ 	}
  
! 	$result = $wpdb->get_var( $query );
  	if ( null === $result )
  		$result = '';
  
  	wp_cache_set($query_key, $result, 'counts');
+ 
+ 	if ( $result )
+ 		$result = get_post( $result );
+ 
  	return $result;
  }
  
***************
*** 1173,1192 ****
   * @return string
   */
  function get_adjacent_post_rel_link($title = '%title', $in_same_cat = false, $excluded_categories = '', $previous = true) {
! 	if ( $previous && is_attachment() && is_object( $GLOBALS['post'] ) )
! 		$post = & get_post($GLOBALS['post']->post_parent);
  	else
! 		$post = get_adjacent_post($in_same_cat,$excluded_categories,$previous);
  
  	if ( empty($post) )
  		return;
  
  	if ( empty($post->post_title) )
! 		$post->post_title = $previous ? __('Previous Post') : __('Next Post');
  
  	$date = mysql2date(get_option('date_format'), $post->post_date);
  
! 	$title = str_replace('%title', $post->post_title, $title);
  	$title = str_replace('%date', $date, $title);
  	$title = apply_filters('the_title', $title, $post->ID);
  
--- 1209,1230 ----
   * @return string
   */
  function get_adjacent_post_rel_link($title = '%title', $in_same_cat = false, $excluded_categories = '', $previous = true) {
! 	if ( $previous && is_attachment() && $post = get_post() )
! 		$post = get_post( $post->post_parent );
  	else
! 		$post = get_adjacent_post( $in_same_cat, $excluded_categories, $previous );
  
  	if ( empty($post) )
  		return;
  
  	if ( empty($post->post_title) )
! 		$post_title = $previous ? __('Previous Post') : __('Next Post');
! 	else
! 		$post_title = $post->post_title;
  
  	$date = mysql2date(get_option('date_format'), $post->post_date);
  
! 	$title = str_replace('%title', $post_title, $title);
  	$title = str_replace('%date', $date, $title);
  	$title = apply_filters('the_title', $title, $post->ID);
  
***************
*** 1265,1273 ****
   * @return object
   */
  function get_boundary_post( $in_same_cat = false, $excluded_categories = '', $start = true ) {
! 	global $post;
! 
! 	if ( empty($post) || ! is_single() || is_attachment() )
  		return null;
  
  	$cat_array = array();
--- 1303,1310 ----
   * @return object
   */
  function get_boundary_post( $in_same_cat = false, $excluded_categories = '', $start = true ) {
! 	$post = get_post();
! 	if ( ! $post || ! is_single() || is_attachment() )
  		return null;
  
  	$cat_array = array();
***************
*** 1337,1369 ****
   * @param array|string $excluded_categories Optional. Array or comma-separated list of excluded category IDs.
   * @param bool $previous Optional, default is true. Whether to display link to previous or next post.
   */
! function adjacent_post_link($format, $link, $in_same_cat = false, $excluded_categories = '', $previous = true) {
  	if ( $previous && is_attachment() )
! 		$post = & get_post($GLOBALS['post']->post_parent);
  	else
! 		$post = get_adjacent_post($in_same_cat, $excluded_categories, $previous);
! 
! 	if ( !$post )
! 		return;
  
! 	$title = $post->post_title;
  
! 	if ( empty($post->post_title) )
! 		$title = $previous ? __('Previous Post') : __('Next Post');
  
! 	$title = apply_filters('the_title', $title, $post->ID);
! 	$date = mysql2date(get_option('date_format'), $post->post_date);
! 	$rel = $previous ? 'prev' : 'next';
  
! 	$string = '<a href="'.get_permalink($post).'" rel="'.$rel.'">';
! 	$link = str_replace('%title', $title, $link);
! 	$link = str_replace('%date', $date, $link);
! 	$link = $string . $link . '</a>';
  
! 	$format = str_replace('%link', $link, $format);
  
  	$adjacent = $previous ? 'previous' : 'next';
! 	echo apply_filters( "{$adjacent}_post_link", $format, $link );
  }
  
  /**
--- 1374,1408 ----
   * @param array|string $excluded_categories Optional. Array or comma-separated list of excluded category IDs.
   * @param bool $previous Optional, default is true. Whether to display link to previous or next post.
   */
! function adjacent_post_link( $format, $link, $in_same_cat = false, $excluded_categories = '', $previous = true ) {
  	if ( $previous && is_attachment() )
! 		$post = get_post( get_post()->post_parent );
  	else
! 		$post = get_adjacent_post( $in_same_cat, $excluded_categories, $previous );
  
! 	if ( ! $post ) {
! 		$output = '';
! 	} else {
! 		$title = $post->post_title;
  
! 		if ( empty( $post->post_title ) )
! 			$title = $previous ? __( 'Previous Post' ) : __( 'Next Post' );
  
! 		$title = apply_filters( 'the_title', $title, $post->ID );
! 		$date = mysql2date( get_option( 'date_format' ), $post->post_date );
! 		$rel = $previous ? 'prev' : 'next';
  
! 		$string = '<a href="' . get_permalink( $post ) . '" rel="'.$rel.'">';
! 		$inlink = str_replace( '%title', $title, $link );
! 		$inlink = str_replace( '%date', $date, $inlink );
! 		$inlink = $string . $inlink . '</a>';
  
! 		$output = str_replace( '%link', $inlink, $format );
! 	}
  
  	$adjacent = $previous ? 'previous' : 'next';
! 
! 	echo apply_filters( "{$adjacent}_post_link", $output, $format, $link, $post );
  }
  
  /**
***************
*** 1385,1393 ****
  
  	$home_root = parse_url(home_url());
  	$home_root = ( isset($home_root['path']) ) ? $home_root['path'] : '';
! 	$home_root = preg_quote( trailingslashit( $home_root ), '|' );
  
! 	$request = preg_replace('|^'. $home_root . '|', '', $request);
  	$request = preg_replace('|^/+|', '', $request);
  
  	if ( !$wp_rewrite->using_permalinks() || is_admin() ) {
--- 1424,1432 ----
  
  	$home_root = parse_url(home_url());
  	$home_root = ( isset($home_root['path']) ) ? $home_root['path'] : '';
! 	$home_root = preg_quote( $home_root, '|' );
  
! 	$request = preg_replace('|^'. $home_root . '|i', '', $request);
  	$request = preg_replace('|^/+|', '', $request);
  
  	if ( !$wp_rewrite->using_permalinks() || is_admin() ) {
***************
*** 1410,1416 ****
  		}
  
  		$request = preg_replace( "|$wp_rewrite->pagination_base/\d+/?$|", '', $request);
! 		$request = preg_replace( '|^index\.php|', '', $request);
  		$request = ltrim($request, '/');
  
  		$base = trailingslashit( get_bloginfo( 'url' ) );
--- 1449,1455 ----
  		}
  
  		$request = preg_replace( "|$wp_rewrite->pagination_base/\d+/?$|", '', $request);
! 		$request = preg_replace( '|^index\.php|i', '', $request);
  		$request = ltrim($request, '/');
  
  		$base = trailingslashit( get_bloginfo( 'url' ) );
***************
*** 1646,1656 ****
   * @return string
   */
  function get_comments_pagenum_link( $pagenum = 1, $max_page = 0 ) {
! 	global $post, $wp_rewrite;
  
  	$pagenum = (int) $pagenum;
  
! 	$result = get_permalink( $post->ID );
  
  	if ( 'newest' == get_option('default_comments_page') ) {
  		if ( $pagenum != $max_page ) {
--- 1685,1695 ----
   * @return string
   */
  function get_comments_pagenum_link( $pagenum = 1, $max_page = 0 ) {
! 	global $wp_rewrite;
  
  	$pagenum = (int) $pagenum;
  
! 	$result = get_permalink();
  
  	if ( 'newest' == get_option('default_comments_page') ) {
  		if ( $pagenum != $max_page ) {
***************
*** 1842,1848 ****
   * @return string Home url link with optional path appended.
  */
  function home_url( $path = '', $scheme = null ) {
! 	return get_home_url(null, $path, $scheme);
  }
  
  /**
--- 1881,1887 ----
   * @return string Home url link with optional path appended.
  */
  function home_url( $path = '', $scheme = null ) {
! 	return get_home_url( null, $path, $scheme );
  }
  
  /**
***************
*** 1863,1882 ****
  function get_home_url( $blog_id = null, $path = '', $scheme = null ) {
  	$orig_scheme = $scheme;
  
! 	if ( !in_array( $scheme, array( 'http', 'https', 'relative' ) ) )
! 		$scheme = is_ssl() && !is_admin() ? 'https' : 'http';
! 
! 	if ( empty( $blog_id ) || !is_multisite() )
  		$url = get_option( 'home' );
! 	else
! 		$url = get_blog_option( $blog_id, 'home' );
  
! 	if ( 'relative' == $scheme )
! 		$url = preg_replace( '#^.+://[^/]*#', '', $url );
! 	elseif ( 'http' != $scheme )
! 		$url = str_replace( 'http://', "$scheme://", $url );
  
! 	if ( !empty( $path ) && is_string( $path ) && strpos( $path, '..' ) === false )
  		$url .= '/' . ltrim( $path, '/' );
  
  	return apply_filters( 'home_url', $url, $path, $orig_scheme, $blog_id );
--- 1902,1925 ----
  function get_home_url( $blog_id = null, $path = '', $scheme = null ) {
  	$orig_scheme = $scheme;
  
! 	if ( empty( $blog_id ) || !is_multisite() ) {
  		$url = get_option( 'home' );
! 	} else {
! 		switch_to_blog( $blog_id );
! 		$url = get_option( 'home' );
! 		restore_current_blog();
! 	}
  
! 	if ( ! in_array( $scheme, array( 'http', 'https', 'relative' ) ) ) {
! 		if ( is_ssl() && ! is_admin() )
! 			$scheme = 'https';
! 		else
! 			$scheme = parse_url( $url, PHP_URL_SCHEME );
! 	}
  
! 	$url = set_url_scheme( $url, $scheme );
! 
! 	if ( ! empty( $path ) && is_string( $path ) && strpos( $path, '..' ) === false )
  		$url .= '/' . ltrim( $path, '/' );
  
  	return apply_filters( 'home_url', $url, $path, $orig_scheme, $blog_id );
***************
*** 1895,1905 ****
   * @uses get_site_url()
   *
   * @param string $path Optional. Path relative to the site url.
!  * @param string $scheme Optional. Scheme to give the site url context. Currently 'http', 'https', 'login', 'login_post', 'admin', or 'relative'.
   * @return string Site url link with optional path appended.
  */
  function site_url( $path = '', $scheme = null ) {
! 	return get_site_url(null, $path, $scheme);
  }
  
  /**
--- 1938,1948 ----
   * @uses get_site_url()
   *
   * @param string $path Optional. Path relative to the site url.
!  * @param string $scheme Optional. Scheme to give the site url context. See set_url_scheme().
   * @return string Site url link with optional path appended.
  */
  function site_url( $path = '', $scheme = null ) {
! 	return get_site_url( null, $path, $scheme );
  }
  
  /**
***************
*** 1918,1950 ****
   * @return string Site url link with optional path appended.
  */
  function get_site_url( $blog_id = null, $path = '', $scheme = null ) {
! 	// should the list of allowed schemes be maintained elsewhere?
! 	$orig_scheme = $scheme;
! 	if ( !in_array( $scheme, array( 'http', 'https', 'relative' ) ) ) {
! 		if ( ( 'login_post' == $scheme || 'rpc' == $scheme ) && ( force_ssl_login() || force_ssl_admin() ) )
! 			$scheme = 'https';
! 		elseif ( ( 'login' == $scheme ) && force_ssl_admin() )
! 			$scheme = 'https';
! 		elseif ( ( 'admin' == $scheme ) && force_ssl_admin() )
! 			$scheme = 'https';
! 		else
! 			$scheme = ( is_ssl() ? 'https' : 'http' );
! 	}
! 
! 	if ( empty( $blog_id ) || !is_multisite() )
  		$url = get_option( 'siteurl' );
! 	else
! 		$url = get_blog_option( $blog_id, 'siteurl' );
  
! 	if ( 'relative' == $scheme )
! 		$url = preg_replace( '#^.+://[^/]*#', '', $url );
! 	elseif ( 'http' != $scheme )
! 		$url = str_replace( 'http://', "{$scheme}://", $url );
  
! 	if ( !empty( $path ) && is_string( $path ) && strpos( $path, '..' ) === false )
  		$url .= '/' . ltrim( $path, '/' );
  
! 	return apply_filters( 'site_url', $url, $path, $orig_scheme, $blog_id );
  }
  
  /**
--- 1961,1980 ----
   * @return string Site url link with optional path appended.
  */
  function get_site_url( $blog_id = null, $path = '', $scheme = null ) {
! 	if ( empty( $blog_id ) || !is_multisite() ) {
  		$url = get_option( 'siteurl' );
! 	} else {
! 		switch_to_blog( $blog_id );
! 		$url = get_option( 'siteurl' );
! 		restore_current_blog();
! 	}
  
! 	$url = set_url_scheme( $url, $scheme );
  
! 	if ( ! empty( $path ) && is_string( $path ) && strpos( $path, '..' ) === false )
  		$url .= '/' . ltrim( $path, '/' );
  
! 	return apply_filters( 'site_url', $url, $path, $scheme, $blog_id );
  }
  
  /**
***************
*** 1958,1964 ****
   * @return string Admin url link with optional path appended.
  */
  function admin_url( $path = '', $scheme = 'admin' ) {
! 	return get_admin_url(null, $path, $scheme);
  }
  
  /**
--- 1988,1994 ----
   * @return string Admin url link with optional path appended.
  */
  function admin_url( $path = '', $scheme = 'admin' ) {
! 	return get_admin_url( null, $path, $scheme );
  }
  
  /**
***************
*** 1975,1984 ****
  function get_admin_url( $blog_id = null, $path = '', $scheme = 'admin' ) {
  	$url = get_site_url($blog_id, 'wp-admin/', $scheme);
  
! 	if ( !empty($path) && is_string($path) && strpos($path, '..') === false )
! 		$url .= ltrim($path, '/');
  
! 	return apply_filters('admin_url', $url, $path, $blog_id);
  }
  
  /**
--- 2005,2014 ----
  function get_admin_url( $blog_id = null, $path = '', $scheme = 'admin' ) {
  	$url = get_site_url($blog_id, 'wp-admin/', $scheme);
  
! 	if ( !empty( $path ) && is_string( $path ) && strpos( $path, '..' ) === false )
! 		$url .= ltrim( $path, '/' );
  
! 	return apply_filters( 'admin_url', $url, $path, $blog_id );
  }
  
  /**
***************
*** 2009,2017 ****
   * @return string Content url link with optional path appended.
  */
  function content_url($path = '') {
! 	$url = WP_CONTENT_URL;
! 	if ( 0 === strpos($url, 'http') && is_ssl() )
! 		$url = str_replace( 'http://', 'https://', $url );
  
  	if ( !empty($path) && is_string($path) && strpos($path, '..') === false )
  		$url .= '/' . ltrim($path, '/');
--- 2039,2045 ----
   * @return string Content url link with optional path appended.
  */
  function content_url($path = '') {
! 	$url = set_url_scheme( WP_CONTENT_URL );
  
  	if ( !empty($path) && is_string($path) && strpos($path, '..') === false )
  		$url .= '/' . ltrim($path, '/');
